/*
	sockets send buffers, so we need to convert objects to raw data.
	sockets receive raw data so we need to parse bytes and unserialize the messages.
	also we need to split input raw data bytes to know where one message ends and the other starts.
	this all is done here.
	
*/

➮ blockParser onBlock {
	all ∆ ⟡ Buffer([])

	$ ➮ - data {
		all = Buffer ꗚ ([all, data])
		∞ {
			⌥ all ↥ >= 4 {
				size = all.readUInt32LE(0)
			}
			⎇ @
			⌥ size <= all↥ {
				block ∆ all ⋃ (4, size)
				all = all ⋃ (size)
				onBlock(block)
			}
		}
	}
}

➮ sendBlock socket msg {
	⌥ ⬤ msg ≠ 'string' { msg = JSON.stringify(msg) }
	size ∆ Buffer.byteLength(msg)
	buf ∆ ⟡Buffer(size + 4)
	buf.writeInt32LE(size + 4, 0)
	buf.write(msg, 4)
	socket.write(buf)
}

module.exports.blockParser = blockParser
module.exports.sendBlock = sendBlock


